function pt = angtrough(xxx,yyy,plotflg)
% ANGTROUGH - Find peaks and troughs based on integrated angles
%    pt = ANGTROUGH(xxx,yyy,plotflg)   
if nargin<3
  plotflg=0;
end
[K N]=size(xxx);
dl=.2; ll=[1:dl:98]';
L=length(ll);
aaa=zeros(L,N);
for n=1:N
  dx = diff(xxx(:,n));
  dy = diff(yyy(:,n));
  a = atan2(dy,dx);
  aa = diff(a);
  aa=mod(aa+pi,2*pi)-pi;
  aaa(:,n) = ginterp([1:98]',aa,ll,5) * 180/pi;
end

if plotflg
  figure(plotflg); clf
  imagesc(aaa);
  caxis([-1 1]*max(abs(caxis)));
  colormap(bluered(256,1));
end

pt = peaktrough(ll,aaa, .5, 40);
