function h=plotmaxdir(imax,dirs,inv,leg)

if nargin<3
  inv=0;
end
if nargin<4
  leg=0;
end

if 0
  qq=sort(imax(:));
  imax=imax/qq(ceil(.999*length(qq)));
else
  imax=imax/max(imax(:));
end
imax(imax<0)=0;
if inv==0
  zz=cat(3,imax.*(cos(dirs)), imax.*(cos(dirs+2*pi/3)), imax.*(cos(dirs+4*pi/3)));
  zz=zz+.5;
else
  zz=cat(3,imax.*(1+cos(dirs)), imax.*(1+cos(dirs+2*pi/3)), imax.*(1+cos(dirs+4*pi/3)));
end
zz(zz<0)=0; 
zz(zz>1)=1;
if inv<0
  zz=1-zz;
end

h=image(zz);

if leg(1)
  if length(leg)>1
    dphi=leg(2);
  else
    dphi=0;
  end
  hold on
  [Y X C]=size(zz);
  S=min([Y X]*.05);
  for phi=[0:.25*pi:1.992*pi]
    phix=phi-dphi;
    clr = [cos(phix),cos(phix+2*pi/3),cos(phix+4*pi/3)];
    if inv~=0
      clr=(clr+1) * .7;
    else
      clr=clr+.5;
    end
    clr(clr<0)=0;
    clr(clr>1)=1;
    if inv<0
      clr=1-clr;
    end
    h=[h; plot(X*.9+[-1 1]*cos(phi*leg(1))*S,...
	Y*(.1+.4*phi/pi)+[-1 1]*sin(phi*leg(1))*S,...
	'color',clr,'linew',2)];
  end
end
