function [xx,yy,im,lp]=tracealong(imax,dirdx,dirdy,thr,xm,ym,scl,stp,rng,dirad)

[Y_,X_] = size(imax);

xx=[];
yy=[];
im=[];
dx0 = interp2(dirdx,xm,ym,'linear');
dy0 = interp2(dirdy,xm,ym,'linear');
d0 = atan2(dy0,dx0) + dirad;
mx = interp2(imax,xm,ym,'linear');

lp=0;
while mx>thr
  xx=[xx;xm];
  yy=[yy;ym];
  im=[im;mx];
  dx1 = interp2(dirdx,xm,ym,'linear');
  dy1 = interp2(dirdy,xm,ym,'linear');
  d1 = atan2(dy1,dx1) / 2;
  while d1>d0+pi/2
    d1=d1-pi;
  end
  while d1<d0-pi/2
    d1=d1+pi;
  end
  d0=d1;
  x_=xm+sin(d1)*stp + [-rng:1/scl:rng]*cos(d1);
  y_=ym+cos(d1)*stp - [-rng:1/scl:rng]*sin(d1);
%  x_=xm+cos(d1)*stp - [-rng:1/scl:rng]*sin(d1);
%  y_=ym+sin(d1)*stp + [-rng:1/scl:rng]*cos(d1);
  ok=find(x_>=1 & x_<=X_ & y_>=1 & y_<=Y_);
  if isempty(ok)
    fprintf(1,'WARNING: Dropping off edge of image region.          \n');
    break
  end
  x_=x_(ok); 
  y_=y_(ok);
  im_ = interp2(imax,x_,y_);
  [mx,id]=max(im_);
  xm=x_(id);
  ym=y_(id);
  if any((xx-xm).^2 + (yy-ym).^2 < 1)
    fprintf(1,'WARNING: Loop detected.                        \n');
    % Let's cut at minimum pixel value
    [mn,id0]=min((xx-xm).^2 + (yy-ym).^2); % Start of loop
    id1=length(xx); % End of loop
    [mx,id] = min(im(id0:ceil(.25*id0+.75*id1)));
    id=id+id0-1; % This is the minimum point
    xx=xx(1:id-1);
    yy=yy(1:id-1);
    im=im(1:id-1);
    lp=1;
    break;
  end
end

% If there is a region of confusion, let's cut this beast short.
dx=diff(xx);
dy=diff(yy);
da=diff(atan2(dy,dx));
da(da>pi) = da(da>pi)-2*pi;
da(da<-pi) = da(da<-pi)+2*pi;
%plot(da)
bad=find(abs(da)>pi/2);
if ~isempty(bad)
  fprintf(1,'WARNING: Cutting off an apparent knot.           \n');
  xx=xx(1:bad(1)-1);
  yy=yy(1:bad(1)-1);
  im=im(1:bad(1)-1);
end
